/*
 *                      Yeppp! library implementation
 *                  This file is auto-generated by Peach-Py,
 *       Portable Efficient Assembly Code-generator in Higher-level Python,
 *                   part of the Yeppp! library infrastrure
 *
 * This file is part of Yeppp! library and licensed under 2-clause BSD license.
 * See library/LICENSE.txt for details.
 *
 */

#include <yepIntrinsics.h>
#include <yepCore.h>


extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_MultiplyAdd_V32fV32fV32f_V32f_Default(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, const Yep32f* YEP_RESTRICT zPointer, Yep32f* YEP_RESTRICT macPointer, YepSize length) {
	while (length-- != 0) {
		const Yep32f x = *xPointer++;
		const Yep32f y = *yPointer++;
		const Yep32f z = *zPointer++;
		const Yep32f mac = x * y + z;
		*macPointer++ = mac;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_MultiplyAdd_V64fV64fV64f_V64f_Default(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, const Yep64f* YEP_RESTRICT zPointer, Yep64f* YEP_RESTRICT macPointer, YepSize length) {
	while (length-- != 0) {
		const Yep64f x = *xPointer++;
		const Yep64f y = *yPointer++;
		const Yep64f z = *zPointer++;
		const Yep64f mac = x * y + z;
		*macPointer++ = mac;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_MultiplyAdd_V32fS32fIV32f_IV32f_Default(const Yep32f* YEP_RESTRICT xPointer, const Yep32f* YEP_RESTRICT yPointer, Yep32f* YEP_RESTRICT zPointer, YepSize length) {

	const Yep32f y = *yPointer;
	while (length-- != 0) {
		const Yep32f x = *xPointer++;
		Yep32f z = *zPointer;
		z = x * y + z;
		*zPointer++ = z;
	}
	return YepStatusOk;
}

extern "C" YEP_LOCAL_SYMBOL YepStatus _yepCore_MultiplyAdd_V64fS64fIV64f_IV64f_Default(const Yep64f* YEP_RESTRICT xPointer, const Yep64f* YEP_RESTRICT yPointer, Yep64f* YEP_RESTRICT zPointer, YepSize length) {

	const Yep64f y = *yPointer;
	while (length-- != 0) {
		const Yep64f x = *xPointer++;
		Yep64f z = *zPointer;
		z = x * y + z;
		*zPointer++ = z;
	}
	return YepStatusOk;
}
