#!/bin/bash
CXX=g++
CXXFLAGS="-m32 -nostdlib -fPIC -ffunction-sections -Wno-psabi -mtune=corei7 -fno-exceptions -fno-unwind-tables -fomit-frame-pointer -fstrict-aliasing -funswitch-loops -Isources -Iheaders -Wa,--noexecstack -DYEP_BUILD_LIBRARY -c"
CC=gcc
AS=nasm
ASFLAGS="-f elf32"
RM=rm
RMFLAGS="-rf"

$RM $RMFLAGS "binaries/x86-linux-pic-i586" >NUL 2>NUL
mkdir "binaries/x86-linux-pic-i586/" >NUL 2>NUL
mkdir "binaries/x86-linux-pic-i586/library/" >NUL 2>NUL
mkdir "binaries/x86-linux-pic-i586/core/" >NUL 2>NUL
mkdir "binaries/x86-linux-pic-i586/math/" >NUL 2>NUL

$CXX -Os $CXXFLAGS sources/core/Add.disp.cpp -o binaries/x86-linux-pic-i586/core/Add.disp.o

$CXX -O3 $CXXFLAGS sources/core/Add.impl.cpp -o binaries/x86-linux-pic-i586/core/Add.impl.o

$AS $ASFLAGS -o binaries/x86-linux-pic-i586/core/Add.x86.o sources/core/Add.x86.asm

$CXX -Os $CXXFLAGS sources/core/Subtract.disp.cpp -o binaries/x86-linux-pic-i586/core/Subtract.disp.o

$CXX -O3 $CXXFLAGS sources/core/Subtract.impl.cpp -o binaries/x86-linux-pic-i586/core/Subtract.impl.o

$AS $ASFLAGS -o binaries/x86-linux-pic-i586/core/Subtract.x86.o sources/core/Subtract.x86.asm

$CXX -Os $CXXFLAGS sources/core/Multiply.disp.cpp -o binaries/x86-linux-pic-i586/core/Multiply.disp.o

$CXX -O3 $CXXFLAGS sources/core/Multiply.impl.cpp -o binaries/x86-linux-pic-i586/core/Multiply.impl.o

$AS $ASFLAGS -o binaries/x86-linux-pic-i586/core/Multiply.x86.o sources/core/Multiply.x86.asm

$CXX -Os $CXXFLAGS sources/core/MultiplyAdd.disp.cpp -o binaries/x86-linux-pic-i586/core/MultiplyAdd.disp.o

$CXX -O3 $CXXFLAGS sources/core/MultiplyAdd.impl.cpp -o binaries/x86-linux-pic-i586/core/MultiplyAdd.impl.o

$AS $ASFLAGS -o binaries/x86-linux-pic-i586/core/MultiplyAdd.x86.o sources/core/MultiplyAdd.x86.asm

$CXX -Os $CXXFLAGS sources/core/Negate.disp.cpp -o binaries/x86-linux-pic-i586/core/Negate.disp.o

$CXX -O3 $CXXFLAGS sources/core/Negate.impl.cpp -o binaries/x86-linux-pic-i586/core/Negate.impl.o

$AS $ASFLAGS -o binaries/x86-linux-pic-i586/core/Negate.x86.o sources/core/Negate.x86.asm

$CXX -Os $CXXFLAGS sources/core/DotProduct.disp.cpp -o binaries/x86-linux-pic-i586/core/DotProduct.disp.o

$CXX -O3 $CXXFLAGS sources/core/DotProduct.impl.cpp -o binaries/x86-linux-pic-i586/core/DotProduct.impl.o

$AS $ASFLAGS -o binaries/x86-linux-pic-i586/core/DotProduct.x86.o sources/core/DotProduct.x86.asm

$CXX -Os $CXXFLAGS sources/core/SumSquares.disp.cpp -o binaries/x86-linux-pic-i586/core/SumSquares.disp.o

$CXX -O3 $CXXFLAGS sources/core/SumSquares.impl.cpp -o binaries/x86-linux-pic-i586/core/SumSquares.impl.o

$AS $ASFLAGS -o binaries/x86-linux-pic-i586/core/SumSquares.x86.o sources/core/SumSquares.x86.asm

$CXX -Os $CXXFLAGS sources/math/Log.disp.cpp -o binaries/x86-linux-pic-i586/math/Log.disp.o

$CXX -O3 $CXXFLAGS sources/math/Log.impl.cpp -o binaries/x86-linux-pic-i586/math/Log.impl.o

$AS $ASFLAGS -o binaries/x86-linux-pic-i586/math/Log.x86.o sources/math/Log.x86.asm

$CXX -Os $CXXFLAGS sources/library/Init.cpp -o binaries/x86-linux-pic-i586/library/Init.o

$CXX -Os $CXXFLAGS sources/library/Cpu.cpp -o binaries/x86-linux-pic-i586/library/Cpu.o

$CXX -Os $CXXFLAGS sources/library/Timer.cpp -o binaries/x86-linux-pic-i586/library/Timer.o

$CXX -Os $CXXFLAGS sources/library/Strings.cpp -o binaries/x86-linux-pic-i586/library/Strings.o

$CXX -m32 -nostdlib -Wl,-soname,libyeppp.so -shared -Wl,--version-script=sources/libyeppp.so.map binaries/x86-linux-pic-i586/core/Add.disp.o binaries/x86-linux-pic-i586/core/Add.impl.o binaries/x86-linux-pic-i586/core/Add.x86.o binaries/x86-linux-pic-i586/core/Subtract.disp.o binaries/x86-linux-pic-i586/core/Subtract.impl.o binaries/x86-linux-pic-i586/core/Subtract.x86.o binaries/x86-linux-pic-i586/core/Multiply.disp.o binaries/x86-linux-pic-i586/core/Multiply.impl.o binaries/x86-linux-pic-i586/core/Multiply.x86.o binaries/x86-linux-pic-i586/core/MultiplyAdd.disp.o binaries/x86-linux-pic-i586/core/MultiplyAdd.impl.o binaries/x86-linux-pic-i586/core/MultiplyAdd.x86.o binaries/x86-linux-pic-i586/core/Negate.disp.o binaries/x86-linux-pic-i586/core/Negate.impl.o binaries/x86-linux-pic-i586/core/Negate.x86.o binaries/x86-linux-pic-i586/core/DotProduct.disp.o binaries/x86-linux-pic-i586/core/DotProduct.impl.o binaries/x86-linux-pic-i586/core/DotProduct.x86.o binaries/x86-linux-pic-i586/core/SumSquares.disp.o binaries/x86-linux-pic-i586/core/SumSquares.impl.o binaries/x86-linux-pic-i586/core/SumSquares.x86.o binaries/x86-linux-pic-i586/math/Log.disp.o binaries/x86-linux-pic-i586/math/Log.impl.o binaries/x86-linux-pic-i586/math/Log.x86.o binaries/x86-linux-pic-i586/library/Cpu.o binaries/x86-linux-pic-i586/library/Timer.o binaries/x86-linux-pic-i586/library/Init.o binaries/x86-linux-pic-i586/library/Strings.o -Wl,--no-undefined -Wl,-z,noexecstack -o binaries/x86-linux-pic-i586/libyeppp.so

strip binaries/x86-linux-pic-i586/libyeppp.so
strip -R .comment -R .note.gnu.build-id binaries/x86-linux-pic-i586/libyeppp.so
